## magics++ 3.0.0

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_C_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=OFF

# Missing dependencies:
#   * ghostscript ( is it really needed? -- to confirm )

cmake_minimum_required( VERSION 2.8.11 FATAL_ERROR )

project( magics CXX )

# make sure that the header files are installed into include/magics
# note that this needs to be done before ecbuild_declare_project()
# to ensure that the ecbuild header files are also put there
# note also that we need to CACHE this so that ecbuild_declare_project() does not overwrite it
set(INSTALL_INCLUDE_DIR include/magics CACHE PATH "Magics installation directory for header files")

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 2.6 )

###############################################################################
# some variables of this project

set(ECCODES_FAIL_MSG "Note: grib_api can be used instead (select with -DENABLE_ECCODES=OFF), "
                      "but we strongly advise you to upgrade to ecCodes. "
                      "See https://software.ecmwf.int/wiki/display/ECC/ecCodes+Home\n"
                      )

ecbuild_add_option( FEATURE ECCODES DESCRIPTION "Use eccodes instead of grib_api"
                    REQUIRED_PACKAGES "PROJECT eccodes VERSION 0.14 REQUIRED FAILURE_MSG ECCODES_FAIL_MSG"
                    DEFAULT ON )

if( HAVE_ECCODES)
  set( GRIB_API_INCLUDE_DIRS ${ECCODES_INCLUDE_DIRS} )
  set( GRIB_API_LIBRARIES    ${ECCODES_LIBRARIES} )
  set( GRIB_API_DEFINITIONS  ${ECCODES_DEFINITIONS} )
  set( grib_api_BASE_DIR     ${eccodes_BASE_DIR} )
  set( grib_handling_pkg eccodes )
else()
  ecbuild_use_package( PROJECT grib_api VERSION 1.14.3 REQUIRED
                       FAILURE_MSG "ecCodes can be used instead (enable with -DENABLE_ECCODES=ON)" )
  set( grib_handling_pkg grib_api )
endif()


# grib_api is required for now
set( HAVE_GRIB 1 )

ecbuild_add_option( FEATURE BUFR
                    DEFAULT ON
                    DESCRIPTION "BUFR support"
                    REQUIRED_PACKAGES "PROJECT libemos VERSION 4.0.5" )

ecbuild_add_option( FEATURE ODB
                    DEFAULT ON
                    DESCRIPTION "ODB support"
                    REQUIRED_PACKAGES "PROJECT odb_api VERSION 0.10.2")
					#	"PROJECT eckit   VERSION 0.9.0" )

ecbuild_add_option( FEATURE CAIRO
                    DEFAULT ON
                    DESCRIPTION "cairo support[png/jpeg]"
                    REQUIRED_PACKAGES PangoCairo Pango PNG)

ecbuild_add_option( FEATURE GEOTIFF
                    DEFAULT OFF
                    DESCRIPTION "geotiff support [implies cairo]"
                    CONDITION HAVE_CAIRO
                    REQUIRED_PACKAGES GeoTIFF )

ecbuild_add_option( FEATURE NETCDF
                    DEFAULT ON
                    DESCRIPTION "enable netcdf support"
                    REQUIRED_PACKAGES "NetCDF 4 COMPONENTS C" )

ecbuild_add_option( FEATURE SPOT
                    DEFAULT OFF
                    DESCRIPTION "enable spot support"
                    REQUIRED_PACKAGES "PROJECT spot" )

ecbuild_add_option( FEATURE PYTHON
                    DEFAULT ON
                    DESCRIPTION "enable python interface"
                    REQUIRED_PACKAGES "Python NO_LIBS" NumPy )

ecbuild_add_option( FEATURE FORTRAN
                    DEFAULT ON
                    DESCRIPTION "enable Fortran interface" )

if( HAVE_FORTRAN )
	ecbuild_enable_fortran( REQUIRED )
endif()

ecbuild_add_option( FEATURE METVIEW
                    DEFAULT OFF
                    DESCRIPTION "enable Metview interface" )

ecbuild_add_option( FEATURE METVIEW_NO_QT
                    DEFAULT OFF
                    DESCRIPTION "enable Metview interface without Qt" )

ecbuild_add_option( FEATURE QT5
                    DEFAULT ON
                    DESCRIPTION "use Qt5 instead of version 4" )

option( BUILD_SHARED_LIBS  "Set to BOTH to build static library in addition to shared"  ON )
option( ENABLE_REGRESSION        "Internal use only: enable regression test"  OFF  )
option( ENABLE_REGRESSION_UPLOAD "Internal use only : enable upload of reference image"  OFF  )

set( MAGICS_NAME          "Magics" )
set( MAGICS_EXCEPTION     "ON" )
set( MAGICS_SITE          "ecmwf" )
set( MAGICS_INSTALL_PATH  ${CMAKE_INSTALL_PREFIX} )

set( MAGICS_REFERENCE_VERSIONS            "2.34.0" )
set( MAGICS_HTML_ROOT        "${CMAKE_BINARY_DIR}/regression/html")
file(MAKE_DIRECTORY ${MAGICS_HTML_ROOT} )

set( MAG_PYTHON_PATH ${CMAKE_CURRENT_BINARY_DIR}/python )

###############################################################################
# projects

# ecbuild_use_package( PROJECT eckit VERSION 0.3 REQUIRED )

#ecbuild_add_cxx_flags("-gdwarf-2")
ecbuild_add_c_flags("-std=c99")

### Metview and Qt
ecbuild_info("TESTING for Metview and Qt ...")

if(HAVE_METVIEW AND HAVE_METVIEW_NO_QT)
    ecbuild_critical("Do not set both HAVE_METVIEW and HAVE_METVIEW_NO_QT - only set one. You may have to remove your CMakeCache.txt to clear these settings.")
endif()

set( qt no )
set( metview no )

if( HAVE_METVIEW_NO_QT )
	set( metview yes )
	unset(MAGICS_ONLY)
endif()

if( HAVE_METVIEW )
    set ( metview yes)
    ecbuild_info("TESTING for Metview ...")
    unset(MAGICS_ONLY)

    if( HAVE_QT5 )
      find_package(Qt5Widgets REQUIRED)
      if( Qt5Widgets_FOUND )
          ecbuild_info("Qt5 was found ... ${Qt5Widgets_VERSION_STRING}")
          include_directories(${Qt5Widgets_INCLUDE_DIRS})
          set( MAGICS_QT 1)
          set( MAGICS_QT5 1)
          set( qt yes)
          add_definitions( -DMAGICS_QT5 )
      else()
          ecbuild_critical("Qt5 was NOT found ...")
      endif()
    else( HAVE_QT5 )
      find_package(Qt4 4.6.2 REQUIRED QtCore QtGui QtXml )
      if( QT_FOUND )
		    include( ${QT_USE_FILE} )
		    set( MAGICS_QT 1)
		    set( qt yes)
      endif()
    endif()
endif()

ecbuild_declare_project()

###############################################################################
# find extra packages

set( CMAKE_THREAD_PREFER_PTHREAD 1 )
find_package( Threads )

# set(Boost_USE_STATIC_LIBS        ON)
# set(Boost_NO_SYSTEM_PATHS        ON)
# set(Boost_USE_MULTITHREADED      ON)
#ecbuild_add_extra_search_paths( boost )

find_package( Boost 1.53.0 REQUIRED)
find_package( Proj4 REQUIRED )
find_package( EXPAT REQUIRED )

###############################################################################
# contents

set( MAGICS_TPLS grib_api spot EXPAT NetCDF Proj4 libemos )

set( MAGICS_INCLUDE_DIRS
     ${CMAKE_CURRENT_SOURCE_DIR}/src
     ${CMAKE_BINARY_SOURCE_DIR}/src
     ${CMAKE_CURRENT_SOURCE_DIR}/src/common
     ${CMAKE_CURRENT_BINARY_DIR}/src/params
     ${CMAKE_CURRENT_BINARY_DIR}/src
     ${CMAKE_CURRENT_SOURCE_DIR}/src/common
     ${CMAKE_CURRENT_SOURCE_DIR}/src/basic
     ${CMAKE_CURRENT_SOURCE_DIR}/src/web
     ${CMAKE_CURRENT_SOURCE_DIR}/src/visualisers
     ${CMAKE_CURRENT_SOURCE_DIR}/src/drivers
     ${CMAKE_CURRENT_SOURCE_DIR}/src/drivers/MgQ
     ${CMAKE_CURRENT_SOURCE_DIR}/src/eckit_readers
     ${CMAKE_CURRENT_SOURCE_DIR}/src/decoders
     ${CMAKE_CURRENT_SOURCE_DIR}/src/terralib
     ${CMAKE_CURRENT_SOURCE_DIR}/src/terralib/kernel
     ${CMAKE_CURRENT_SOURCE_DIR}/src/libMagWrapper
     ${Boost_INCLUDE_DIRS} )

if( HAVE_CAIRO )
  list( APPEND MAGICS_TPLS PangoCairo PNG PANGO)
  list( APPEND MAGICS_INCLUDE_DIRS ${PANGOCAIRO_INCLUDE_DIRS} )
endif()

if( HAVE_ODB )
  list( APPEND MAGICS_TPLS odb_api )
  list( APPEND MAGICS_INCLUDE_DIRS
        ${CMAKE_CURRENT_SOURCE_DIR}/src/oda
        ${ODB_API_INCLUDE_DIRS}
		${ECKIT_INCLUDE_DIRS} )
endif()

set( MAGICS_LIBRARIES    MagPlus )

foreach( _tpl ${MAGICS_TPLS} )
    string( TOUPPER ${_tpl} TPL )
    if( NOT ${TPL} STREQUAL "LIBEMOS" ) # don't add libemos definitions
    list( APPEND MAGICS_EXTRA_DEFINITIONS   ${${TPL}_DEFINITIONS}  )
    endif()
    list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${${TPL}_INCLUDE_DIRS} )
    string(REGEX REPLACE "[ ]+$" "" ${TPL}_LIBRARIES "${${TPL}_LIBRARIES}") # strips leading whitespaces
    string(REGEX REPLACE "^[ ]+" "" ${TPL}_LIBRARIES "${${TPL}_LIBRARIES}") # strips trailing whitespaces
    list( APPEND MAGICS_EXTRA_LIBRARIES     ${${TPL}_LIBRARIES} )
    ecbuild_info("${TPL}_LIBRARIES [${${TPL}_LIBRARIES}]") # add this to confirm that indeed it was cleaned up
endforeach()

if( HAVE_BUFR )
	list( APPEND MAGICS_EXTRA_DEFINITIONS   fortfloat=double fortint=int )
endif()
if( WITH_QT_DEBUG )
	list( APPEND MAGICS_EXTRA_DEFINITIONS QT_NO_DEBUG_OUTPUT )
endif()

if( MAGICS_QT )
  if( MAGICS_QT5 )
    list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${Qt5Widgets_INCLUDE_DIR} )
    list( APPEND MAGICS_EXTRA_LIBRARIES     ${Qt5Widgets_LIBRARIES} )
  else()
	list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${QT_INCLUDE_DIR} )
	list( APPEND MAGICS_EXTRA_LIBRARIES     ${QT_LIBRARIES} )
endif()
endif()

if( HAVE_GEOTIFF )
	list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${GEOTIFF_INCLUDE_DIR} )
	list( APPEND MAGICS_EXTRA_LIBRARIES  ${GEOTIFF_LIBRARY} )
  list( APPEND MAGICS_EXTRA_DEFINITIONS HAVE_GEOTIFF )
endif()

list( APPEND MAGICS_EXTRA_LIBRARIES     ${CMAKE_THREAD_LIBS_INIT} )

ecbuild_debug("MAGICS_EXTRA_DEFINITIONS  => ${MAGICS_EXTRA_DEFINITIONS}")
ecbuild_debug("MAGICS_EXTRA_INCLUDE_DIRS => ${MAGICS_EXTRA_INCLUDE_DIRS}")
ecbuild_debug("MAGICS_EXTRA_LIBRARIES    => ${MAGICS_EXTRA_LIBRARIES}")

# set_directory_properties( PROPERTIES COMPILE_DEFINITIONS "${ECKIT_DEFINITIONS}" )
get_directory_property( MAGICS_DEFINITIONS COMPILE_DEFINITIONS )

include_directories( ${MAGICS_INCLUDE_DIRS} ${MAGICS_EXTRA_INCLUDE_DIRS} )

# scripts
add_subdirectory( tools )

# source files
add_subdirectory( src )

# shared files
add_subdirectory( share )

# python interface
add_subdirectory( python )

# apps directory
add_subdirectory( apps )

# Test directory
add_subdirectory( test )
if( ENABLE_REGRESSION )
    add_subdirectory( regression )
endif()

# Directories not need in the distribution tar ball!
ecbuild_add_resources( TARGET old_src DONT_PACK_DIRS src/MvObs src/libTable src/xml src/terralib/functions)
ecbuild_add_resources( TARGET bamboo DONT_PACK_DIRS bamboo)
ecbuild_add_resources( TARGET old_ressources
		DONT_PACK_DIRS tools/versioncmp
		tools/regression
		regression
		docs
		toolsjs
		notebook
		test/old
		tools/xml
		tools/use_scripts
		tools/versioncmp_folders)

ecbuild_add_resources( TARGET internal
		DONT_PACK configure.lxab
		configure.local
		configure.ecgb
		configure.ecmwf
)

############################################################################################
# finalize

set( MAGICS_DESCRIPTION "Multi-platform meteorological graphics library" )
set( MAGICS_URL "https://software.ecmwf.int/wiki/display/MAGP/Magics" )
ecbuild_pkgconfig()

ecbuild_install_project( NAME Magics )

ecbuild_print_summary()

=== python/CMakeLists.txt ===

if( HAVE_PYTHON )

  configure_file( setup.py.in setup.py )
  configure_file( Magics.py.in Magics/Magics.py )

  # Copy python modules to build area
  # configure_file ensures the copy is triggered if the file changes
  configure_file( Magics/__init__.py Magics/__init__.py COPYONLY )
  configure_file( Magics/macro.py Magics/macro.py COPYONLY )
  configure_file( Magics/toolbox.py Magics/toolbox.py COPYONLY )
  configure_file( Magics/metgram.py Magics/metgram.py COPYONLY )

#  ${CMAKE_SHARED_LIBRARY_SUFFIX}   ${CMAKE_BINARY_DIR}/lib

  # Build the extension module for use in install tree with RPATH pointing to install tree
  install(CODE "execute_process(COMMAND ${PYTHON_EXECUTABLE} setup.py build_ext --rpath ${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR} WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})")

  # Library installation directory override
  if( NOT INSTALL_LIB_DIR STREQUAL lib )
      execute_process( COMMAND ${PYTHON_EXECUTABLE} -c "from __future__ import print_function; import sys; print(sys.version[:3], end='')"
               OUTPUT_VARIABLE PYVER )
      set( __install_lib "--install-lib=${MAGICS_FULL_INSTALL_LIB_DIR}/python${PYVER}/site-packages" )
  endif()

  # Call distutils for installation
  install(CODE "execute_process(COMMAND ${PYTHON_EXECUTABLE} setup.py install ${__install_lib} --root \$ENV{DESTDIR}/ --prefix ${CMAKE_INSTALL_PREFIX} WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})")

endif()

=== src/CMakeLists.txt ===
###############################################################################

configure_file( magics_config.h.in  magics_config.h  )

install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/magics_config.h  DESTINATION ${INSTALL_INCLUDE_DIR})

###############################################################################


function( add_metview_definition_file )

    set( single_value_args ACTION BASENAME FILE )
    cmake_parse_arguments( _p "${options}" "${single_value_args}" "${multi_value_args}"  ${_FIRST_ARG} ${ARGN} )

    add_custom_command(
            OUTPUT ${_p_BASENAME}Def ${_p_BASENAME}Rules
            COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../../tools/xml2mv.py ${CMAKE_CURRENT_SOURCE_DIR} ${_p_FILE}  ${_p_BASENAME}Def ${_p_ACTION} ${_p_BASENAME}Rules
            DEPENDS ${_p_FILE}
      )


    add_custom_target( ${_p_BASENAME} ALL DEPENDS ${_p_BASENAME}Def)
    install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/${_p_BASENAME}Def ${CMAKE_CURRENT_BINARY_DIR}/${_p_BASENAME}Rules DESTINATION ${INSTALL_DATA_DIR}/../magics/metview)

endfunction(add_metview_definition_file)

add_subdirectory( params )



foreach( file ${magics_xmls} )

      get_filename_component( path     ${file} PATH   )
      get_filename_component( basefile ${file} NAME_WE )

      set( ouputfiles ${path}/${basefile}Attributes.h ${path}/${basefile}Attributes.cc )

      # generate the code
      add_custom_command(
            OUTPUT  ${ouputfiles}
            COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../tools/xml2cc.py ${CMAKE_CURRENT_SOURCE_DIR}/../tools/ ${CMAKE_CURRENT_SOURCE_DIR}/${file} ${CMAKE_CURRENT_BINARY_DIR}/params nosubdir
            DEPENDS ${file}
      )

      set_source_files_properties( ${basefile}Attributes.h  GENERATED )
      set_source_files_properties( ${basefile}Attributes.cc GENERATED )

      list( APPEND magics_params_srcs ${ouputfiles} )

endforeach()

if ( metview )

	foreach( file ${metview_xmls} )
	      get_filename_component( path     ${file} PATH   )
          get_filename_component( basefile ${file} NAME_WE )

		  set( metviewfiles ${path}/${basefile}Wrapper.h ${path}/${basefile}Wrapper.cc )


		# generate the code
		  add_custom_command(
				OUTPUT  ${metviewfiles}
				COMMAND ${PERL_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../tools/xml2mv.pl ${CMAKE_CURRENT_SOURCE_DIR}/${file} ${CMAKE_CURRENT_BINARY_DIR}/params nosubdir
				DEPENDS ${file}
			)

		  set_source_files_properties( ${basefile}Wrapper.h  GENERATED )
          set_source_files_properties( ${basefile}Wrapper.cc GENERATED )
          list( APPEND metview_wrappers_srcs ${metviewfiles} )
      endforeach()

     if(qt)
        SET(qt_drivers_HEADERS drivers/MgQ/MgQPlotScene.h)
        if( MAGICS_QT5 )
          QT5_WRAP_CPP(qt_drivers_HEADERS_MOC ${qt_drivers_HEADERS})
        else()
          QT4_WRAP_CPP(qt_drivers_HEADERS_MOC ${qt_drivers_HEADERS})
        endif()
        list( APPEND drivers_srcs  drivers/MgQ/MgQPlotScene.cc  ${qt_drivers_HEADERS_MOC})
     endif()
endif()


add_custom_target( magics_params DEPENDS ${magics_params_srcs} )
add_custom_target( mv_params DEPENDS ${metview_wrappers_srcs} )
###############################################################################

add_subdirectory( common )
add_subdirectory( basic )
add_subdirectory( web )
add_subdirectory( visualisers )
add_subdirectory( drivers )
add_subdirectory( decoders )
add_subdirectory( terralib )
add_subdirectory( clipper )
add_subdirectory( eckit_readers )

if( metview )
	add_subdirectory( libMagWrapper )
endif()

if( HAVE_ODB )
	add_subdirectory( oda )
endif()

include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/common )

ecbuild_add_library( TARGET    MagPlus
                     DEPENDS   magics_params
                     SOURCES
                        magics.h
                        ${magics_params_srcs}
                        ${common_srcs}
                        ${basic_srcs}
                        ${web_srcs}
                        ${visualisers_srcs}
                        ${eckit_srcs}
                        ${drivers_srcs}
                        ${qt_srcs}
                        ${decoders_srcs}
                        ${clipper_srcs}
                        ${terralib_srcs}
                        ${odb_srcs}
                     TEMPLATES
                        ${common_templates}
                     DEFINITIONS
                        ${MAGICS_EXTRA_DEFINITIONS} MAGICS_EXCEPTION=on
                     LIBS
                        ${MAGICS_EXTRA_LIBRARIES}
                     TYPE SHARED )

ecbuild_add_library( TARGET      MagPlusSingle
                     SOURCES     MagicsSingle.cc
                     LIBS        MagPlus
                     TYPE        SHARED )

ecbuild_add_library( TARGET      MagPlusDouble
                     SOURCES     MagicsDouble.cc
                     LIBS        MagPlus
                     TYPE        SHARED )

if ( BUILD_SHARED_LIBS STREQUAL "BOTH" )
ecbuild_add_library( TARGET    MagPlusStatic
                     DEPENDS   magics_params
                     SOURCES
                        magics.h
                        ${magics_params_srcs}
                        ${common_srcs}
                        ${basic_srcs}
                        ${web_srcs}
                        ${visualisers_srcs}
                        ${eckit_srcs}
                        ${drivers_srcs}
                        ${qt_srcs}
                        ${decoders_srcs}
                        ${clipper_srcs}
                        ${terralib_srcs}
                        ${odb_srcs}
                     TEMPLATES
                        ${common_templates}
                     DEFINITIONS
                        ${MAGICS_EXTRA_DEFINITIONS}
                     LIBS
                        ${MAGICS_EXTRA_LIBRARIES}
                     TYPE STATIC
                     OUTPUT_NAME MagPlus )

ecbuild_add_library( TARGET      MagPlusSingleStatic
                     SOURCES     MagicsSingle.cc
                     LIBS        MagPlusStatic
                     TYPE        STATIC
                     OUTPUT_NAME MagPlusSingle )

ecbuild_add_library( TARGET      MagPlusDoubleStatic
                     SOURCES     MagicsDouble.cc
                     LIBS        MagPlusStatic
                     TYPE        STATIC
                     OUTPUT_NAME MagPlusDouble )

endif()

if( metview )
 include_directories(  ${CMAKE_CURRENT_SOURCE_DIR}
                        ${CMAKE_CURRENT_BINARY_DIR}
                        ${CMAKE_CURRENT_BINARY_DIR}/params
                        ${CMAKE_CURRENT_SOURCE_DIR}/common
                        ${CMAKE_CURRENT_SOURCE_DIR}/basic
                        ${CMAKE_CURRENT_SOURCE_DIR}/web
                        ${CMAKE_CURRENT_SOURCE_DIR}/visualisers
                        ${CMAKE_CURRENT_SOURCE_DIR}/drivers
                        ${CMAKE_CURRENT_SOURCE_DIR}/decoders
                        ${CMAKE_CURRENT_SOURCE_DIR}/clipper
                        ${CMAKE_CURRENT_SOURCE_DIR}/terralib/kernel
                        ${CMAKE_CURRENT_SOURCE_DIR}/libMagWrapper )



  ecbuild_add_library( TARGET    MagWrapper
                     DEPENDS   mv_params magics_params
                     SOURCES
                        magics.h
                        ${metview_srcs}
                        ${metview_wrappers_srcs}
                     DEFINITIONS
                        ${MAGICS_EXTRA_DEFINITIONS}
                    LIBS
                        ${MAGICS_EXTRA_LIBRARIES}
                    TYPE STATIC
                    )
   list( APPEND attributes_include
				OutputHandlerAttributes.h
				FortranRootSceneNodeAttributes.h
                BinningObjectAttributes.h
                GribDecoderAttributes.h
                DateGribLoopStepAttributes.h
                GribLoopAttributes.h
                GeoRectangularProjectionAttributes.h
                LegendVisitorAttributes.h
				XmlRootNodeAttributes.h
				WrepRootNodeAttributes.h
                ContinuousLegendMethodAttributes.h
                HistogramLegendMethodAttributes.h
                XmlBasicNodeAttributes.h
                #ImagePlottingAttributes.h
                LookupTableModeAttributes.h
                FixedTableModeAttributes.h
				)
   if(qt)
     list(APPEND attributes_include
                 QtDriverAttributes.h)
   endif()

   install( FILES terralib/kernel/TeProjection.h
				   terralib/kernel/TeCoord2D.h
				   terralib/kernel/TeDefines.h
				   terralib/kernel/TePrecision.h
				   terralib/kernel/TeSingleton.h
				   terralib/kernel/TeDatum.h
				   terralib/kernel/TeUtils.h


				   DESTINATION ${INSTALL_INCLUDE_DIR})
   install( FILES VectorOfPointers.h  DESTINATION ${INSTALL_INCLUDE_DIR})
   foreach( file ${attributes_include} )
     install( FILES ${CMAKE_CURRENT_BINARY_DIR}/params/${file}  DESTINATION ${INSTALL_INCLUDE_DIR})
   endforeach()
   install( FILES ${metview_include} DESTINATION ${INSTALL_INCLUDE_DIR})
endif()
install( FILES magics.h  DESTINATION ${INSTALL_INCLUDE_DIR})

=== test/CMakeLists.txt ===


set( grib_environment
    GRIB_DEFINITION_PATH=${grib_api_BASE_DIR}/share/${grib_handling_pkg}/definitions
    GRIB_SAMPLES_PATH=${grib_api_BASE_DIR}/share/${grib_handling_pkg}/samples )
    
# Basic test 
ecbuild_add_test( TARGET basic_c
                  SOURCES   coast.c
                  LIBS      MagPlusSingle MagPlus
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  LINKER_LANGUAGE C )

ecbuild_add_test( TARGET basic_python
                  TYPE PYTHON
                  CONDITION HAVE_PYTHON
                  ARGS coast.py
                  RESOURCES coast.py 
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH}
                              LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/.. )

ecbuild_add_test( TARGET basic_fortran_shared
                  SOURCES   coast.f90
                  LIBS      MagPlusSingle MagPlus
                  CONDITION HAVE_FORTRAN
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  LINKER_LANGUAGE Fortran )

ecbuild_add_test( TARGET basic_fortran_static
                  SOURCES   coast.f90
                  LIBS      MagPlusSingleStatic MagPlusStatic ${MAGICS_EXTRA_LIBRARIES} 
                  CONDITION HAVE_FORTRAN AND BUILD_SHARED_LIBS STREQUAL "BOTH"
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  LINKER_LANGUAGE Fortran )       

ecbuild_add_test( TARGET bufr_python
                  TYPE PYTHON
                  CONDITION HAVE_BUFR AND HAVE_PYTHON
                  ARGS bufr.py
                  RESOURCES bufr.py data.bufr 
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH}
                              LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/.. )

ecbuild_add_test( TARGET bufr_fortran
                  SOURCES   bufr.f90
                  LIBS      MagPlusSingle MagPlus
                  CONDITION HAVE_BUFR AND HAVE_FORTRAN
                  RESOURCES data.bufr
                  LINKER_LANGUAGE Fortran 
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..)

ecbuild_add_test( TARGET bufr_fortran_static
                  SOURCES   bufr.f90
                  RESOURCES data.bufr
                  LIBS      MagPlusSingleStatic MagPlusStatic
                  CONDITION HAVE_BUFR AND HAVE_FORTRAN AND BUILD_SHARED_LIBS STREQUAL "BOTH"
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  LINKER_LANGUAGE Fortran )       

ecbuild_add_test( TARGET grib_python
                  TYPE PYTHON
                  CONDITION HAVE_GRIB AND HAVE_PYTHON
                  ARGS grib.py
                  RESOURCES grib.py data.grib
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH}
                              LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                              ${grib_environment} )

ecbuild_add_test( TARGET grib_fortran
                  SOURCES   grib.f90
                  LIBS      MagPlusSingle MagPlus
                  RESOURCES data.grib
                  CONDITION HAVE_GRIB AND HAVE_FORTRAN
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  ${grib_environment}
                  LINKER_LANGUAGE Fortran 
                  )

ecbuild_add_test( TARGET cairo_python
                  TYPE PYTHON
                  CONDITION HAVE_CAIRO AND HAVE_PYTHON
                  ARGS cairo.py
                  RESOURCES cairo.py 
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH}
                              LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/.. )

ecbuild_add_test( TARGET cairo_fortran
                  SOURCES   cairo.f90
                  LIBS      MagPlusSingle MagPlus
                  CONDITION HAVE_CAIRO AND HAVE_FORTRAN
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  LINKER_LANGUAGE Fortran )

ecbuild_add_test( TARGET odb_python
                  TYPE PYTHON
                  CONDITION HAVE_ODB AND HAVE_PYTHON
                  ARGS odb.py
                  RESOURCES odb.py test.odb
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH}
                              LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/.. )

=== apps/MagMLInterpretor/CMakeLists.txt ===


configure_file( magjson-script.in  magjson @ONLY )
configure_file( magml-script.in  magml @ONLY )

install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/magjson 
			DESTINATION ${INSTALL_BIN_DIR} 
			PERMISSIONS OWNER_READ GROUP_READ WORLD_READ 
				        OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/magml 
			DESTINATION ${INSTALL_BIN_DIR} 
			PERMISSIONS OWNER_READ GROUP_READ WORLD_READ 
				        OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

ecbuild_add_executable( TARGET    magjsonx
                     SOURCES
                        json.cc
                     DEFINITIONS
                        ${MAGICS_EXTRA_DEFINITIONS}
                    LIBS
                        MagPlus ${MAGICS_EXTRA_LIBRARIES}
                    )
                    
ecbuild_add_executable( TARGET    magmlx
                     SOURCES
                        magml.cc
                     DEFINITIONS
                        ${MAGICS_EXTRA_DEFINITIONS}
					 LIBS
                        MagPlus ${MAGICS_EXTRA_LIBRARIES}
                    )

=== apps/metgram/CMakeLists.txt ===
# Copy metgram executable to the build tree
configure_file( metgram  metgram COPYONLY )
configure_file( metgram-script.in  metgram.sh @ONLY )

# Set metgram script path for use by dependencies in a bundle
set( MAGICS_METEOGRAM_SCRIPT ${CMAKE_CURRENT_SOURCE_DIR}/metgram
     CACHE FILEPATH "Path to metgram script" )

install( DIRECTORY templates/ DESTINATION ${INSTALL_DATA_DIR}
         FILE_PERMISSIONS OWNER_READ GROUP_READ WORLD_READ )

install ( FILES ${CMAKE_CURRENT_SOURCE_DIR}/metgram  ${CMAKE_CURRENT_BINARY_DIR}/metgram.sh 
			DESTINATION ${INSTALL_BIN_DIR} 
			PERMISSIONS OWNER_READ GROUP_READ WORLD_READ 
				        OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)


ecbuild_add_executable( TARGET    metgramx
                     SOURCES
                        metgramx.cc
                     DEFINITIONS
                        ${MAGICS_EXTRA_DEFINITIONS}
                    LIBS
                        MagPlus ${MAGICS_EXTRA_LIBRARIES}
                    )

=== src/basic/CMakeLists.txt ===
set( _basic_srcs
BasicGraphicsObject.cc
BasicGraphicsObject.h
BasicSceneObject.cc
BasicSceneObject.h
BasicSceneVisitor.cc
BasicSceneVisitor.h
FortranMagics.cc
FortranMagics.h
HistoVisitor.cc
HistoVisitor.h
ImportObjectHandler.cc
ImportObjectHandler.h
Layer.cc
Layer.h
LayoutManager.cc
LayoutManager.h
LegendVisitor.cc
LegendVisitor.h
MagicsEvent.h
MagicsObserver.h
MagnifierVisitor.cc
MagnifierVisitor.h
MultiVisdef.cc
MultiVisdef.h
ParameterSettings.cc
ParameterSettings.h
PreviewVisitor.cc
PreviewVisitor.h
RootSceneNode.cc
RootSceneNode.h
SceneNode.cc
SceneNode.h
SceneVisitor.cc
SceneVisitor.h
TagHandler.cc
TagHandler.h
TextVisitor.cc
TextVisitor.h
ViewNode.cc
ViewNode.h
Visdef.h
VisualAction.cc
VisualAction.h
WebFormat.cc
WebFormat.h
XmlMagics.cc
XmlMagics.h
)
if ( metview )
	list (APPEND metview_include 
			basic/MagicsObserver.h 
			basic/MagicsEvent.h
			basic/RootSceneNode.h
			basic/BasicSceneObject.h
			basic/BasicGraphicsObject.h
			basic/DisplayManager.h
			basic/Layer.h
			basic/SceneVisitor.h 
			basic/XmlMagics.h 
			basic/LegendVisitor.h 
			basic/Visdef.h 
			)
	set( metview_include ${metview_include} PARENT_SCOPE )
endif()

foreach( file ${_basic_srcs} )
  list( APPEND basic_srcs basic/${file} )
endforeach()

set( basic_srcs ${basic_srcs} PARENT_SCOPE )

=== src/clipper/CMakeLists.txt ===
set( _clipper_srcs
# headers
    clipper.hpp clipper.cpp 
)
foreach( file ${_clipper_srcs} )
  list( APPEND clipper_srcs clipper/${file} )
endforeach()

set( clipper_srcs ${clipper_srcs} PARENT_SCOPE )

=== src/terralib/CMakeLists.txt ===
set( _terralib_srcs
# headers
     kernel/TeProjection.h kernel/TeProjection.cpp 
     kernel/TeDatum.cpp kernel/TeDatum.h 
     kernel/TeUtils.h kernel/TeUtils.cpp
     kernel/TeGeometry.h kernel/TeGeometry.cpp
     kernel/TeMultiGeometry.h kernel/TeMultiGeometry.cpp
     kernel/TeBox.h kernel/TeBox.cpp
     kernel/TeErrorLog.h kernel/TeErrorLog.cpp
     kernel/TeException.h kernel/TeException.cpp
     kernel/TeCoord2D.h kernel/TeDefines.h kernel/TePrecision.h kernel/TeSingleton.h kernel/TeComposite.h kernel/TeCounted.h kernel/TeMeasure.h kernel/TeDataTypes.h
)
foreach( file ${_terralib_srcs} )
  list( APPEND terralib_srcs terralib/${file} )
endforeach()

set( terralib_srcs ${terralib_srcs} PARENT_SCOPE )

=== src/visualisers/CMakeLists.txt ===
set( _visualisers_srcs
Akima760.cc
Akima760Method.h
Akima474.cc
Akima474Method.h
ArrowPlotting.cc
ArrowPlotting.h
AutomaticContourMethod.h
Axis.cc
Axis.h
AxisControl.cc
AxisControl.h
AxisItem.cc
AxisItem.h
AxisLine.h
AxisMethod.cc
AxisMethod.h
AxisType.cc
AxisType.h
Bar.cc
Bar.h
BothValuePlotMethod.h
Boundaries.cc
Boundaries.h
BoxPlotBasicItem.h
BoxPlotItem.cc
BoxPlotItem.h
BoxPlotVisualiser.cc
BoxPlotVisualiser.h
CalculateColourTechnique.cc
CalculateColourTechnique.h
GradientsColourTechnique.cc
GradientsColourTechnique.h
CalcStreamlines.cc  
CalcStreamlines.h
CalmIndicator.h
CellShading.cc
CellShading.h
Cities.cc
Cities.h
CoastPlotting.cc
CoastPlotting.h
Coastlines.cc
Coastlines.h
ColourSelection.cc
ColourSelection.h
ColourTechnique.cc
ColourTechnique.h
Contour.cc
Contour.h
ContourLibrary.cc
ContourLibrary.h
ContourMethod.h
CountSelectionType.cc
CountSelectionType.h
Curve.cc
Curve.h
DateAxis.cc
DateAxis.h
DefinitionTable.h
DefinitionTable.hcc
DotPolyShadingMethod.h
EpsForecastPlot.h
EpsGraph.cc
EpsGraph.h
EquidistantTableMode.cc
EquidistantTableMode.h
Filter.cc
Filter.h
FlagPlotting.cc
FlagPlotting.h
FloatSelection.cc
FloatSelection.h
Graph.h
GraphPlotting.cc
GraphPlotting.h
GraphShade.cc
GraphShade.h
GraphShadeStyle.cc
GraphShadeStyle.h
GribTables.h
GridPlotting.cc
GridPlotting.h
HatchPolyShadingMethod.h
HeightSelection.cc
HeightSelection.h
HeightSelectionCount.h
HeightSelectionList.h
HeightTechnique.cc
HeightTechnique.h
HiLo.cc
HiLo.h
HiLoBase.h
HiLoBoth.h
HiLoMarker.h
HiLoMarkerBase.h
HiLoNumber.h
HiLoText.h
HiLoTechnique.h
HistoIndividualMode.h
HistoMode.h
HistoTableMode.h
Histogram.cc
Histogram.h
ImageCalculateColourTechnique.h
ImageListColourTechnique.h
ImportPlot.h
IntervalSelectionType.cc
IntervalSelectionType.h
Intervals.h
IsoHelper.cc
IsoHelper.h
IsoHighlight.h
IsoLabel.cc
IsoLabel.h
IsoPlot.cc
IsoPlot.h
IsoShading.cc
IsoShading.h
LabelPlotting.cc
LabelPlotting.h
LabelPlottingBase.h
LegendMethod.cc
LegendMethod.h
LevelListSelectionType.cc
LevelListSelectionType.h
LevelSelection.cc
LevelSelection.h
LinearTableMode.cc
LinearTableMode.h
ListColourTechnique.cc
ListColourTechnique.h
LookupTableMode.cc
LookupTableMode.h
MarkerSelection.h
MarkerSelectionCount.h
MarkerSelectionList.h
MarkerShadingTechnique.cc
MarkerShadingTechnique.h
MarkerValuePlotMethod.h
MetgramGraph.cc
MetgramGraph.h
MetgramStyle.cc
MetgramStyle.h
NormalTableMode.cc
NormalTableMode.h
ObsItem.h
ObsItemFamily.cc
ObsItemFamily.h
ObsPlotting.cc
ObsPlotting.h
ObsTable.cc
ObsTable.h
OriginMarker.h
OutLayerTechnique.cc
OutLayerTechnique.h
PolyShadingMethod.cc
PolyShadingMethod.h
PolyShadingTechnique.cc
PolyShadingTechnique.h
ShadingTechnique.h
SegmentJoiner.h
SegmentJoiner.cc
SimplePolylineVisualiser.cc
SimplePolylineVisualiser.h
Streamlines.h
Streamlines.cc
SymbolAdvancedTableMode.cc
SymbolAdvancedTableMode.h
SymbolMode.cc
SymbolMode.h
SymbolPlotting.cc
SymbolPlotting.h
TaylorGrid.cc
TaylorGrid.h
TephiGrid.cc  
TephiGrid.h
TextOrientation.cc
TextOrientation.h
UserDate.cc
UserDate.h
ValuePlot.cc
ValuePlot.h
ValuePlotBase.h
ValuePlotMethod.h
VisDefInfo.cc
VisDefInfo.h
Wind.cc
Wind.h
WindPlotting.cc
WindPlotting.h
)

foreach( file ${_visualisers_srcs} )
  list( APPEND visualisers_srcs visualisers/${file} )
endforeach()

set( visualisers_srcs ${visualisers_srcs} PARENT_SCOPE )

if ( metview )
    list (APPEND metview_include 
            visualisers/LegendMethod.h      
            visualisers/LookupTableMode.h
            )
    set( metview_include ${metview_include} PARENT_SCOPE )
endif()

=== debian/changelog ===
magics++ (3.0.0-1) unstable; urgency=medium

  * New upstream release 
   - Update unique_ptr.patch
   - python3 changes now upstream
   - python*-jinja2 dependendencies now needed
  * S-V: 4.1.2; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 01 Jan 2018 12:18:22 +0000

magics++ (2.34.3-6) unstable; urgency=medium

  * Fix typo in control file. Closes: #881577

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 20 Nov 2017 15:29:03 +0000

magics++ (2.34.3-5) unstable; urgency=medium

  * libmagics++-dev now depends on libodb-api-dev. Closes: #881577

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 13 Nov 2017 08:52:41 +0000

magics++ (2.34.3-4) unstable; urgency=medium

  * Require odb-api >= 0.17..4 for renamed odb executable.
    Closes: #881180

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 12 Nov 2017 06:44:02 +0000

magics++ (2.34.3-3) unstable; urgency=medium

  * Build using odb-api.
  * Change references in cmake files from libgfortran.so.3 to so.4

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 07 Nov 2017 18:04:23 +0000

=== debian/control ===
Source: magics++
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper  (>= 10) , dh-buildinfo, gfortran, cmake, chrpath,
 dh-python,  swig,
 python-dev, python-numpy, 
 python3-dev, python3-numpy,
 python-jinja2,
 python3-jinja2,
 libhdf5-dev | libhdf5-mpi-dev, 
 libnetcdf-dev, libnetcdf-cxx-legacy-dev,
 libgl1-mesa-dev, libgd-dev, 
 libemos-dev (>=  2:4.3.9), libgeotiff-dev,
 libodb-api-dev (>= 0.17.4-3),
 libeccodes-dev | libgrib-api-dev (>= 1.14.5-2), 
 libeccodes-tools | libgrib-api-tools, 
 libemos-bin, libopenjp2-7-dev,
 libaec-dev,
 libterralib-dev, 
 libcairo2-dev, libpango1.0-dev,
 ttf-dejavu-core, libxml-parser-perl, 
 ghostscript, zlib1g-dev, libboost-dev | libboost1.63-dev, libproj-dev, 
 qtbase5-dev-tools, qtbase5-dev, qt5-qmake
Standards-Version: 4.1.2
Homepage: https://software.ecmwf.int/wiki/display/MAGP/Magics
Vcs-Git: git://anonscm.debian.org/debian-science/packages/magics.git

Package: libmagplus3v5
Section: libs
Architecture: any
Multi-Arch: same
Depends: libmagics++-data,${misc:Depends}, ${shlibs:Depends}, ttf-dejavu-core, ttf-dejavu-extra, ghostscript
Description: ECMWF meteorological plotting software library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 The library supports the plotting of contours, wind fields, observations,
 satellite images, symbols, text, axis and graphs (including boxplots).
 .
 Data fields to be plotted may be presented in various formats,
 for instance GRIB 1 and 2 code data, Gaussian grid, regularly spaced grid
 and fitted data. Input data can also be in BUFR and NetCDF format
 or retrieved from an ODB database.
 .
 The produced meteorological plots can be saved in various formats,
 such as PostScript, EPS, PDF, GIF, PNG, SVG and KML.

Package: libmagics++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${python:Depends}, 
 libterralib-dev, magics++, libodb-api-dev
Recommends: pkg-config
Description: Development files for ECMWF  plotting software MAGICS++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package includes the header files and static libraries needed to build 
 against libmagics++.

Package: magics++
Architecture: any
Multi-Arch: foreign
Depends: libmagplus3v5 ( = ${binary:Version} ),
 ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
Description: Executables for the magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package contains the MagcML binary that may be used with magics++.

Package: python-magics++
Section: python
Architecture: any
Depends:  libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, 
 python, python-simplejson, python-jinja2
Description: python support for Magics++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package provides python support for the magics++ library.

Package: python3-magics++
Section: python
Architecture: any
Depends:  libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, 
 python3-simplejson, python3-jinja2
Description: Python3 support for Magics++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package provides Python3 support for the magics++ library.

Package: libmagics++-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Data files needed for magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package contains data expected by the magics++ library.


Package: libmagics++-metview-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmagplus3v5 ( = ${binary:Version} )
Description: Libraries needed for building MetView
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package includes the header files and static libraries needed to build
 metview against magics++.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# To enable all, uncomment following line
# DEB_BUILD_MAINT_OPTIONS:= hardening=+all,-pie
CXXFLAGS:= -fPIC $(shell dpkg-buildflags --get CXXFLAGS) # -std=c++14
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Set for build reproducibility
LC_ALL=C
export LC_ALL

export QT_SELECT=5

LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
AUTOGENERATED:= libmagplus3v5.links libmagics++-dev.links libmagplus3v5.install
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@ --parallel --with python2,python3 --with-buildsystem=cmake

# To fix cmake output change these
OLD_GF_PATH=$(shell gfortran -print-search-dirs | grep install | cut -f2 -d' '  )libgfortran.so
NEW_GF_PATH:=$(LIBDIR)/libgfortran.so.4

# -DCMAKE_PREFIX_PATH=${LIBDIR}/cmake/grib_api \

export extra_flags +=  \
	-DBUILD_SITE=debian \
	-DENABLE_LIBGD=1 \
	-DHAVE_BOOST=1 \
	-DHAVE_ODB=1 \
	-DHAVE_DLFCN_H=1 \
	-DHAVE_INTTYPES_H=1 \
	-DHAVE_LIBEXPAT=1 \
	-DHAVE_LIBPROJ=1 \
	-DHAVE_LIBPTHREAD=1 \
	-DHAVE_LIBZ=1 \
	-DHAVE_MEMORY_H=1 \
	-DHAVE_STDINT_H=1 \
	-DHAVE_STDLIB_H=1 \
	-DHAVE_STRINGS_H=1 \
	-DHAVE_STRING_H=1 \
	-DHAVE_SYS_STAT_H=1 \
	-DHAVE_STS_TYPES_H=1 \
	-DHAVE_UNISTD_H=1 \
	-DMAGICS_ALLHEADERS=1 \
	-DMAGICS_GRIB=1 \
	-DMAGICS_JSON=1 \
	-DMAGICS_METVIEW=1 \
	-DMAGICS_GIF=1 \
	-DMAGICS_GIF_ANIMATED=1 \
	-DMAGICS_TIFF=1 \
	-DMAGICS_TTF=1 \
	-DMAGICS_TTF_PATH="share/magics/ttf/" \
	-DMAGICS_SITE="debian" \
	-DMAGICS_PYTHON=1 \
	-DMAGICS_THREADS=1 \
	-DDISABLE_OS_CHECK=ON \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DBUILD_DOCUMENTATION=ON \
	-DENABLE_FORTRAN=ON \
	-DENABLE_LARGE_FILE_SUPPORT=ON \
	-DENABLE_PYTHON=ON \
	-DBUILD_EXAMPLES=ON \
	-DBUILD_SHARED_LIBS=ON \
	-DENABLE_TESTS=ON \
	-DENABLE_GEOTIFF=ON \
	-DGEOTIFF_INCLUDE_DIR=/usr/include/geotiff \
	-Dodb_api_DIR=${LIBDIR}/cmake/odb_api \
	-DENABLE_RPATHS=OFF \
	-DENABLE_CAIRO=ON \
	-DENABLE_BUFR=ON \
	-DENABLE_GRIB=ON \
	-DENABLE_METVIEW=ON \
	-DENABLE_QT5=ON \
	-DENABLE_NETCDF=ON \
	-DCMAKE_CXX_FLAGS='$(CXXFLAGS) -I/usr/include/terralib -I/usr/include/terralib/kernel' \
	-DMAGICS_EXTRA_LIBRARIES='-lterralib -lgd -lemosR64' 

export LD_LIBRARY_PATH:=$(CURDIR)/debian/tmp/usr/lib:$(LD_LIBRARY_PATH)

override_dh_auto_clean:
	rm -rf debian/build-py*
	rm -f bin/magjsonx  bin/magmlx  bin/metgramx
	find . -type l -delete
	rm -f src/params/*.h src/decoders/*Attributes.h
	rm -rf share/magics/ttf src/terralib debian/build src/boost
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})

override_dh_auto_configure:
	# link for font for tesing.
	mkdir -p share/fonts/truetype/ttf-dejavu/
	ln -sf /usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf share/fonts/truetype/ttf-dejavu/
	# Link terralib
	[ -e src/terralib ] || ln -sf  /usr/include/terralib src/terralib
	for f in ${AUTOGENERATED} ; do \
                sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
                done
	dh_auto_configure --builddirectory=debian/build-py3 -- \
		-DPYTHON_EXECUTABLE=/usr/bin/python3 \
	       	$(extra_flags) 
	dh_auto_configure --builddirectory=debian/build-py2 -- \
		-DPYTHON_EXECUTABLE=/usr/bin/python \
	       	$(extra_flags) 
	(cd python/Magics && ln -s $(CURDIR)/debian/build-py3/python/Magics/Magics.i )

override_dh_auto_build:
	dh_auto_build  --builddirectory=debian/build-py2
	dh_auto_build  --builddirectory=debian/build-py3

override_dh_auto_test check:
	# echo "Tests disabled; see README-testfailures.txt for details"
	# (ulimit -s 8192; export PYTHONPATH=$(CURDIR)/debian/build-py2/python/Magics ; \
	#	export MAGPLUS_HOME=$(CURDIR) ; $(MAKE) -C debian/build-py2  check )
	#(ulimit -s 8192; export PYTHONPATH=$(CURDIR)/debian/build-py3/python/Magics ; \
	#	export MAGPLUS_HOME=$(CURDIR) ; $(MAKE) -C debian/build-py3  check )

override_dh_auto_install:
	(cd  debian/build-py2/python && python2 ./setup.py install --prefix=$(CURDIR)/debian/tmp/usr )
	(cd  debian/build-py3/python && python3 ./setup.py install --prefix=$(CURDIR)/debian/tmp/usr )
	dh_auto_install --builddirectory=debian/build-py3
	# Move lib stuff
	mkdir -p debian/tmp/$(LIBDIR)
	cp -a debian/tmp/usr/lib/*.a debian/tmp/usr/lib/pkgconfig debian/tmp/$(LIBDIR)
	cp debian/tmp/usr/lib/libMagPlus.so debian/tmp/$(LIBDIR)/libMagPlus.so.3.0.0
	# Fixup the cmake files.
	mkdir -p debian/tmp/$(LIBDIR)/cmake/magics
	cp -a debian/tmp/usr/share/magics/cmake/* debian/tmp/$(LIBDIR)/cmake/magics
	sed -e 's%$${_IMPORT_PREFIX}/lib%$(LIBDIR)%' \
		< debian/tmp/usr/share/magics/cmake/magics-targets-none.cmake \
	| sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%' \
	| sed -e 's%$(OLD_GF_PATH)%$(NEW_GF_PATH)%'   \
		> debian/tmp/$(LIBDIR)/cmake/magics/magics-targets-none.cmake
	rm -r debian/tmp/usr/share/magics/cmake
	dh_python2 /usr/lib/python2.7/site-packages/Magics
	dh_python3 /usr/lib/python3*/site-packages/Magics
	dh_numpy -p python-magics++
	dh_numpy3 -p python3-magics++
	-find debian/tmp/usr/bin -type f  -exec chrpath -d {} \;
	-find debian/tmp debian/libmagplus3v5   -name '*.so*' -exec chrpath -d {} \;

override_dh_makeshlibs:
	# For new symbols when compiled with GCC 7
	dh_makeshlibs -V'libmagplus3v5 (>= 2.34.1-2~)'

override_dh_fixperms-arch:
	dh_fixperms
	find debian/tmp debian/python*-magics++   -name '*.so*' -exec chrpath -d {} \;
